/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.application.frames.tabs;

import java.awt.Point;
import org.visnow.vn.application.frames.*;
import java.util.Collection;
import java.util.HashMap;
import javax.swing.DefaultComboBoxModel;
import org.visnow.vn.engine.commands.Command;
import org.visnow.vn.engine.commands.SelectedModuleCommand;
import org.visnow.vn.engine.main.ModuleBox;
import org.visnow.vn.system.swing.VNSwingUtils;

/**
 *
 * @author gacek
 */
public class MPortsPanel extends javax.swing.JPanel
{

    //<editor-fold defaultstate="collapsed" desc=" [VAR] Frames ">
    protected Frames frames;

    public Frames getFrames()
    {
        return frames;
    }

    //</editor-fold>
    //    private javax.swing.JTree tree;
    private HashMap<String, InfoPanel> panels;

    public InfoPanel getPanel(String name)
    {
        if (!panels.containsKey(name)) {
            panels.put(name, new InfoPanel(frames.getApplication().getEngine().getModule(name)));
        }
        return panels.get(name);
    }

    /**
     * Creates new form GUIPanel
     */
    public MPortsPanel(Frames frames)
    {
        this.frames = frames;
        initComponents();
        refreshModules();
        panels = new HashMap<String, InfoPanel>();
        enableScrollBar();
    }

    public void enableScrollBar()
    {
        this.scrollPane.getVerticalScrollBar().setEnabled(true);
        this.scrollPane.getVerticalScrollBar().setMaximum(10000);
    }

    //<editor-fold defaultstate="collapsed" desc=" Generated code ">
    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        comboBox = new javax.swing.JComboBox();
        scrollPane = new javax.swing.JScrollPane();

        setLayout(new java.awt.BorderLayout());

        comboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        comboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboBoxActionPerformed(evt);
            }
        });
        add(comboBox, java.awt.BorderLayout.NORTH);

        scrollPane.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        add(scrollPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents
     //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc=" Actions ">
    public boolean selectModule(String name)
    {
        if (name == null) {
            scrollPane.setViewportView(null);
            if (comboBox.getItemCount() > 0)
                comboBox.setSelectedIndex(comboBox.getItemCount() - 1);
        } else {
            comboBox.setSelectedItem(name);
            scrollPane.setViewportView(getPanel(name));
            getPanel(name).setParentScrollPane(scrollPane);
            VNSwingUtils.setConstantWidth(getPanel(name), scrollPane.getViewport().getWidth());//this.getWidth());
            enableScrollBar();
            repaint();
        }

        return true;
    }

    private void comboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboBoxActionPerformed
        if (comboBox.getItemCount() > 0 && comboBox.getSelectedIndex() == comboBox.getItemCount() - 1)
            return;

        if (getFrames().isSelectingEnabled()) {
            getFrames().getApplication().getReceiver().receive(
                new SelectedModuleCommand(Command.UI_FRAME_SELECTED_MODULE, (String) comboBox.getSelectedItem())
            );
        }
    }//GEN-LAST:event_comboBoxActionPerformed

    public void refreshModules()
    {
        Collection<ModuleBox> modules = getFrames().getApplication().getEngine().getModules().values();
        DefaultComboBoxModel model = new DefaultComboBoxModel();
        for (ModuleBox module : modules) {
            model.addElement(module.getName());
        }
        model.addElement("");
        comboBox.setModel(model);

    }

    //</editor-fold>
    //<editor-fold defaultstate="collapsed" desc=" Generated variables ">
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox comboBox;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    //</editor-fold>

}
